// Copyright (c) 2016, 2018, 2020, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Resource Manager API
//
// API for the Resource Manager service.
// Use this API to install, configure, and manage resources via the "infrastructure-as-code" model.
// For more information, see
// Overview of Resource Manager (https://docs.cloud.oracle.com/iaas/Content/ResourceManager/Concepts/resourcemanager.htm).
//

package resourcemanager

import (
	"encoding/json"
	"github.com/oracle/oci-go-sdk-24/common"
)

// ConfigurationSourceProviderCollection Collection of configuration source providers.
type ConfigurationSourceProviderCollection struct {

	// Collection of configuration source providers.
	Items []ConfigurationSourceProviderSummary `mandatory:"false" json:"items"`
}

func (m ConfigurationSourceProviderCollection) String() string {
	return common.PointerString(m)
}

// UnmarshalJSON unmarshals from json
func (m *ConfigurationSourceProviderCollection) UnmarshalJSON(data []byte) (e error) {
	model := struct {
		Items []configurationsourceprovidersummary `json:"items"`
	}{}

	e = json.Unmarshal(data, &model)
	if e != nil {
		return
	}
	var nn interface{}
	m.Items = make([]ConfigurationSourceProviderSummary, len(model.Items))
	for i, n := range model.Items {
		nn, e = n.UnmarshalPolymorphicJSON(n.JsonData)
		if e != nil {
			return e
		}
		if nn != nil {
			m.Items[i] = nn.(ConfigurationSourceProviderSummary)
		} else {
			m.Items[i] = nil
		}
	}

	return
}
